%define php_sapi cgi

Name: php-cgi
Version: %php_version
Release: %php_release.1
Summary: The PHP4 HTML-embedded scripting language as a CGI binary.
Group: System/Servers
Url: http://www.php.net/
License: PHP
%add_serial php-devel

Requires: zlib, php-libs = 1:%php_version-%php_release

Source1: %name-php.ini
Source2: %name-browscap.ini

Patch0:	 php-cgi-config9.m4.patch
Patch1:	 php-sapi-cgi.patch

# Automatically added by buildreq on Tue Feb 03 2004
BuildRequires: libexpat-devel zlib-devel libalternatives-devel
BuildRequires: php-libs = 1:%php_version-%php_release 
BuildRequires: php-devel = 1:%php_version-%php_release

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  
Using PHP as a CGI binary is an option for setups that for some reason 
do not wish to integrate PHP as a module into server software (like Apache), 
or will use PHP with different kinds of CGI wrappers to create safe 
chroot and setuid environments for scripts. 
This setup usually involves installing executable PHP binary to the 
web server cgi-bin directory. CERT advisory CA-96.11 recommends 
against placing any interpreters into cgi-bin.

%prep
%setup -T -c
%php_sapi_prepare %php_sapi

%patch0 -p1
%patch1 -p1

%build
# fix simple bug.
%__mv config9.m4 config.m4

%__mkdir_p sapi modules

%__ln_s ../ sapi/%php_sapi
echo -n > modules/z

cd ext/bcmath
phpize 
%configure
cd -

CGI_BUILD_VARS=" \
    install_targets=install-sapi \
    PHP_SAPI=default \
    PHP_MODULES=sapi/%php_sapi/php \
    EXTRA_LIBS=-lphp-%php_version \
    BUILD_DIR=./ \
"

phpize $CGI_BUILD_VARS
%configure \
    --disable-static \
    --enable-discard-path \
    --enable-cgi \
    --with-php-config=%_bindir/php-config \
    $CGI_BUILD_VARS 

%php_make 

%install
%__mkdir_p %buildroot/%_bindir
%php_make_install install-sapi program_suffix=-%php_sapi-%php_version

%__mkdir_p %buildroot/%php_servicedir/%php_sapi
%__mkdir_p %buildroot/%php_sysconfdir/%php_sapi/php.d

%__install -m 644 %SOURCE1 %buildroot/%php_sysconfdir/%php_sapi/php.ini
%__install -m 644 %SOURCE2 %buildroot/%php_sysconfdir/%php_sapi/browscap.ini
%__subst 's/@php_version@/%php_version/g' %buildroot/%php_sysconfdir/%php_sapi/php.ini

# Make alternatives support.
%__install -d %buildroot/%_altdir
php_weight=$(echo "%php_version" | sed 's/\.//g')

cat << EOF > %buildroot/%_altdir/php-%php_sapi-%php_version.xml 
<group name="candidate">
	<option name="link">%_bindir/php-%php_sapi</option>
	<option name="real">%_bindir/php-%php_sapi-%php_version</option>
	<option name="weight" type="number">$php_weight</option>
</group>
EOF

%pre
if [ -f "%_sysconfdir/php/%name/php.ini" ]; then
    %__mkdir_p %php_sysconfdir/%name/php.d/
    %__cp %_sysconfdir/php/%name/php.ini %php_sysconfdir/%name/
    %__cp %_sysconfdir/php/%name/php.d/* %php_sysconfdir/%name/php.d
    echo "                                                                  "
    echo "          === WARNING! WARNING! WARNING! ===                      "
    echo " From php version 4.3.6-alt0.cvs20040330 php-cgi config file      " 
    echo " will be locate at %php_sysconfdir/%name/. Current config will be " 
    echo " _coped_ to the new location.                                     "
    echo "                                                                  "
fi

%post
%register_alternatives php-%php_sapi-%php_version.xml 
%php_sapi_postin

%preun
%unregister_alternatives php-%php_sapi-%php_version.xml 
%php_sapi_preun

%files
%_bindir/php-%php_sapi-%php_version
%_altdir/php-%php_sapi-%php_version.xml 
%config(noreplace) %php_sysconfdir/%php_sapi/php.ini
%php_sysconfdir/%php_sapi
%php_servicedir/%php_sapi
%doc CREDITS

%changelog
* Fri Aug 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.9-alt0.cvs20040802.1
- php.ini bugfix (#4946);

* Fri Aug 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.9-alt0.cvs20040802
- New cvs snapshot;
- security fixes;

* Mon May 31 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040531
- New cvs snapshot;
- Environment variable PHPRC overriding is removed.

* Wed May 26 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040519.1
- Update %%patch1. He was broken.

* Mon May 24 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040519
- New cvs snapshot;
- Support alternatives added;
- Remove config files to new place /etc/php/%%php_version/cgi .

* Fri Jan 30 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20040130
- New cvs snapshot.
- Shared Memory support added (enable-shmop).
